/*****************************************************************************
 * Copyright (c) 2013 CEA LIST.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *  Camille Letavernier (CEA LIST) camille.letavernier@cea.fr - Initial API and implementation
 *****************************************************************************/
package org.eclipse.papyrus.infra.ui.services;

import org.eclipse.papyrus.infra.core.services.IService;

/**
 * The LifecycleManager for IMultiDiagramEditor
 *
 * It notifies its listeners when the state of the editor changes
 *
 * @author Camille Letavernier
 *
 */
public interface EditorLifecycleManager extends IService {

	public void addEditorLifecycleEventsListener(EditorLifecycleEventListener listener);

	public void removeEditorLifecycleEventsListener(EditorLifecycleEventListener listener);

}
